Port_Psg equ 7fh

Psg_ToneA equ 00h
Psg_VolumeA equ 10h
Psg_ToneB equ 20h
Psg_VolumeB equ 30h
Psg_ToneC equ 40h
Psg_VolumeC equ 50h

    dseg
tempo equ 220

count equ 3
Channel_Ptr equ 0
Channel_Start equ Channel_Ptr+2
Channel_Len equ Channel_Start+2
Channel_Vol equ Channel_Len+1
unitSize equ Channel_Vol+1

Wait defb 0
Channels defs unitSize*count
time: defw 0
end_of_dseg: public end_of_dseg


cseg

InitSound_: public InitSound_
    ld ix,Channels
    ld b,count
    ld de,unitSize
    xor a
    do
        ld (ix+Channel_Ptr),a
        ld (ix+Channel_Ptr+1),a
        add ix,de
    dwnz
    ld hl,0
    ld (time),hl
ret

ToneOn:
; in
;   hl : cycle
    push af | push hl
        ld a,l
        and 0fh
        or 80h or Psg_ToneA
        out (Port_Psg),a
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,hl
        ld a,h
        and 3fh
        out (Port_Psg),a
        ld a,80h or Psg_VolumeA
        out (Port_Psg),a
    pop hl | pop af
ret

ToneWait:
; in
;   a: length
    ld (Wait),a
    do
        ld a,(Wait)
        or a
    while nz | wend
ret

ToneOff:
    ld a,8fh or Psg_VolumeA
    out (Port_Psg),a
ret


Sound_Get_: public Sound_Get_
    push af | push hl | push de
        ld hl, 283
        call ToneOn
        ld a,3
        call ToneWait
        call ToneOff
    pop de | pop hl | pop af
ret


Sound_Hit_: public Sound_Hit_
    push af | push hl | push de
        ld hl, 300
        do
            Sound_Hit_.Loop:
            call ToneOn
            ld a,1
            call ToneWait
            dec hl
            dec hl
            dec hl
            dec hl
            dec hl
            ld a,h
            or a
            jr nz,Sound_Hit_.Loop
            ld a,l
            cp 150
        while nz | wend
        call ToneOff
    pop de | pop hl | pop af
ret

Sound_Miss_: 
    public Sound_Miss_
    push af | push hl | push de
        ld hl, 150
        do
            Sound_Miss_Loop:
            call ToneOn
            ld a,1
            call ToneWait
            inc hl
            inc hl
            inc hl
            inc hl
            inc hl
            ld a,h
            or a
            jr z,Sound_Miss_Loop
            ld a,l
            cp 300-256
        while nz | wend
        call ToneOff
    pop de | pop hl | pop af
ret


Sound_Loose_: public Sound_Loose_
    push af | push hl | push de
        ld hl, 1000
        call ToneOn
        ld a,6
        call ToneWait
        call ToneOff
    pop de | pop hl | pop af
ret

SoundHandler: public SoundHandler
    ld a,(Wait)
    or a
    if nz
        dec a
        ld (Wait),a
    endif

    push hl | push de
        ld hl,(time)
        ld de,-tempo
        add hl,de
        if nc
            push hl | push bc | push ix
                ld ix,Channels
                ld bc,(count * 100h) or Psg_ToneA   ; b = count; c = register
                do
                    ld l,(ix+Channel_Ptr)
                    ld h,(ix+Channel_Ptr+1)
                    ld a,l
                    or h
                    if nz
                        dec (ix+Channel_Len)
                        if z
                            continue:
                            ld a,(hl)
                            or a
                            if z
                                ; end
                                ld (ix+Channel_Ptr),a
                                ld (ix+Channel_Ptr+1),a
                                ld a,c
                                or 9fh
                                out (Port_Psg),a
                                jr next
                            endif
                            inc a
                            if z 
                                ; repeat
                                ld l,(ix+Channel_Start)
                                ld h,(ix+Channel_Start+1)
                                jr continue
                            endif
                            dec a
                            ld (ix+Channel_Len),a
                            inc hl
                            ld a,(hl)
                            inc hl
                            ld (ix+Channel_Ptr),l
                            ld (ix+Channel_Ptr+1),h
                            or a
                            if nz
                                dec a
                                add a,a
                                ld e,a
                                ld d,0
                                ld hl,cycles
                                add hl,de
                                ld a,c
                                or 80h
                                or (hl)
                                out (Port_Psg),a
                                inc hl
                                ld a,(hl)
                                out (Port_Psg),a
                                ld a,c
                                cp Psg_ToneC
                                if z 
                                    ld a,4
                                else
                                    xor a
                                endif
                                ld (ix+Channel_Vol),a
                            else
                                ld (ix+Channel_Vol),15
                            endif
                        endif
                        ld a,c
                        or (ix+Channel_Vol)
                        or 90h
                        out (Port_Psg),a
                        ld a,(ix+Channel_Vol)
                        cp 15
                        if nz
                            inc a
                            ld (ix+Channel_Vol),a
                        endif
                    endif
                    next:
                    ld a,c
                    add a,20h
                    ld c,a
                    ld de,unitSize
                    add ix,de
                dwnz
            pop ix | pop bc | pop hl
            ld de,600
            add hl,de
        endif
        ld (time),hl
    pop de | pop hl
ret

MelodyWait:
    di
    ld (Channels+Channel_Ptr),hl
    ld a,1
    ld (Channels+Channel_Len),a
    ei
    do
        ld hl,(Channels+Channel_Ptr)
        ld a,l
        or h
    while nz | wend
ret 

B2 equ 1
C3 equ 2
CS3 equ 3
D3 equ 4
DS3 equ 5
E3 equ 6
F3 equ 7
FS3 equ 8
G3 equ 9
GS3 equ 10
A3 equ 11
AS3 equ 12
B3 equ 13
C4 equ 14
CS4 equ 15
D4 equ 16
DS4 equ 17
E4 equ 18
F4 equ 19
FS4 equ 20
G4 equ 21
GS4 equ 22
A4 equ 23
AS4 equ 24
B4 equ 25
C5 equ 26


start_notes: defb 3,C4, 3,G4, 3,E4, 3,G4, 12,C5, 0
Sound_Start_: public Sound_Start_
    push af | push hl
        ld hl,start_notes
        call MelodyWait
    pop hl | pop af
ret

clear_notes: defb 3,C4, 3,E4, 3,G4, 3,D4, 3,F4, 3,A4, 3,E4, 3,G4, 3,B4, 9,C5,0
Sound_Clear_: public Sound_Clear_
    push af | push hl
        ld hl,clear_notes
        call MelodyWait
    pop hl | pop af
ret

over_notes: defb 3,C5, 3,G4, 3,E4, 3,C5,  3,B4, 3,G4, 3,E4, 3,B4,  6,A4, 6,B4,  12,C5, 0
Sound_GameOver_: public Sound_GameOver_
    push af | push hl
        ld hl,over_notes
        call MelodyWait
    pop hl | pop af
ret


BGM_B: 
    defb 3,D4, 3,F4, 3,G4
    defb 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4
    defb 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,A4, 3,G4
    defb 12,F4, 12,G4, 15,A4
    defb 3,D4, 3,F4, 3,G4
    defb 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4
    defb 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,A4, 3,G4
    defb 12,F4, 12,G4, 15,F4
    defb 0ffh
BGM_C: 
    defb 9,0
    defb 9,F3, 9,F3, 6,F3
    defb 9,C3, 9,C3, 6,C3
    defb 12,F3, 12,G3, 15+9,A3
    defb 9,A3, 9,A3, 6,A3
    defb 9,G3, 9,G3, 6,G3
    defb 12,F3, 12,C3, 15,F3
    defb 0ffh

StartBGM_: public StartBGM_
    push af | push hl
        di
        ld a,1
        ld hl,BGM_B
        ld (Channels+unitSize*1+Channel_Start),hl
        ld (Channels+unitSize*1+Channel_Ptr),hl
        ld (Channels+unitSize*1+Channel_Len),a
        ld hl,BGM_C
        ld (Channels+unitSize*2+Channel_Start),hl
        ld (Channels+unitSize*2+Channel_Ptr),hl
        ld (Channels+unitSize*2+Channel_Len),a
        ei
    pop hl | pop af
ret

StopBGM_: public StopBGM_
    push af | push hl | push bc
        di
        ld hl,0
        ld (Channels+unitSize*1+Channel_Ptr),hl
        ld (Channels+unitSize*2+Channel_Ptr),hl
        ld b,3
        ld a, Psg_VolumeB or 8fh
        do
            out (Port_Psg),a
            add a,20h
        dwnz
        ei
    pop bc | pop hl | pop af
ret


cycles:
defb 9,56 ; B2
defb 7,53 ; C3
defb 7,50 ; C#3
defb 9,47 ; D3
defb 15,44 ; D#3
defb 6,42 ; E3
defb 0,40 ; F3
defb 12,37 ; F#3
defb 10,35 ; G3
defb 10,33 ; G#3
defb 12,31 ; A3
defb 15,29 ; A#3
defb 4,28 ; B3
defb 11,26 ; C4
defb 3,25 ; C#4
defb 12,23 ; D4
defb 7,22 ; D#4
defb 3,21 ; E4
defb 0,20 ; F4
defb 14,18 ; F#4
defb 13,17 ; G4
defb 13,16 ; G#4
defb 14,15 ; A4
defb 15,14 ; A#4
defb 2,14 ; B4
defb 5,13 ; C5
; defb 9,12 ; C#5
; defb 14,11 ; D5
; defb 3,11 ; D#5
; defb 9,10 ; E5
; defb 0,10 ; F5
; defb 7,9 ; F#5
; defb 14,8 ; G5
